unit fMain;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, uPSComponent, uPSCompiler, Menus,
  uPSRuntime, Variants, uPSUtils, uPSComponent_Default, uPSC_strutils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    PSImport_Classes1: TPSImport_Classes;
    PSImport_StrUtils1: TPSImport_StrUtils;
    Splitter1: TSplitter;
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Compile1: TMenuItem;
    PSScript: TPSScript;
    procedure PSScriptCompile(Sender: TPSScript);
    procedure Compile1Click(Sender: TObject);
    procedure PSScriptCompImport(Sender: TObject; x: TPSPascalCompiler);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TATest = record
    Test1:integer;
    Test2:integer;
  end;

type
  TATests = array of TATest;

var
  Form1: TForm1;

implementation
uses
  uPSR_std,
  uPSC_std,
  uPSR_stdctrls,
  uPSC_stdctrls,
  uPSR_forms,
  uPSC_forms,
  uPSC_graphics,
  uPSC_controls,
  uPSC_classes,
  uPSR_graphics,
  uPSR_controls,
  uPSR_classes;
  //uPSC_comobj,
  //uPSR_comobj;

procedure Test(daValue:TATests);
var
  i:integer;
begin
  for i:=0 to Length(daValue)-1 do ShowMessage(IntToStr(daValue[i].Test1));
end;

{$R *.lfm}



function ImportTest(S1: string; s2: Longint; s3: Byte; s4: word; var s5: string): string;
begin
  Result := s1 + ' ' + IntToStr(s2) + ' ' + IntToStr(s3) + ' ' + IntToStr(s4) + ' - OK!';
  S5 := s5 + ' '+ result + ' -   OK2!';
end;

procedure MyWriteln(const s: string);
begin
  Form1.Memo2.Lines.Add(s);
end;

function MyReadln(const question: string): string;
begin
  Result := InputBox(question, '', '');
end;

procedure TForm1.PSScriptCompile(Sender: TPSScript);
begin
  Sender.AddFunction(@Test,'procedure test(daValue:TATests);');
end;

procedure TForm1.Compile1Click(Sender: TObject);
  procedure OutputMessages;
  var
    l: Longint;
    b: Boolean;
  begin
    b := False;

    for l := 0 to PSScript.CompilerMessageCount - 1 do
    begin
      Memo2.Lines.Add('Compiler: '+ PSScript.CompilerErrorToStr(l));
      if (not b) and (PSScript.CompilerMessages[l] is TIFPSPascalCompilerError) then
      begin
        b := True;
        Memo1.SelStart := PSScript.CompilerMessages[l].Pos;
      end;
    end;
  end;
begin
  Memo2.Lines.Clear;
  PSScript.Script.Assign(Memo1.Lines);
  Memo2.Lines.Add('Compiling');
  if PSScript.Compile then
  begin
    OutputMessages;
    Memo2.Lines.Add('Compiled succesfully');
    if not PSScript.Execute then
    begin
      Memo1.SelStart := PSScript.ExecErrorPosition;
      Memo2.Lines.Add(PSScript.ExecErrorToString +' at '+Inttostr(PSScript.ExecErrorProcNo)+'.'+Inttostr(PSScript.ExecErrorByteCodePosition));
    end else Memo2.Lines.Add('Succesfully executed');
  end else
  begin
    OutputMessages;
    Memo2.Lines.Add('Compiling failed');
  end;
end;

procedure TForm1.PSScriptCompImport(Sender: TObject; x: TPSPascalCompiler);
var
  RecordType: TPSRecordType;
  FieldDef: PIFPSRecordFieldTypeDef;
begin
  RecordType := TPSRecordType(x.AddType('TATest', btRecord));
  FieldDef := RecordType.AddRecVal;
  FieldDef.FieldOrgName := 'Test1';
  FieldDef.aType := x.FindType('Integer');
  FieldDef := RecordType.AddRecVal;
  FieldDef.FieldOrgName := 'Test2';
  FieldDef.aType := x.FindType('Integer');
  x.AddTypeS('TATests', 'Array of TATest');
end;

end.
